;; Biblioteca simple de sprites de 16x16 que se mueven de 8 en 8 para BASIC
;; la idea es usarlo desde BASIC compilado.

;; Copyleft 2009 The Mojon Twins.
;; Pergreado por na_th_an

;; salo y modifcalo como te de la gana, pero "porfa", mencinanos :-)

;; Usa UDGs y los lee de donde digan las variables del sistema.

;; Supuestamente esto sirve para mover hasta cuatro sprites por la pantalla
;; conservando los fondos.

;; A ver qu tal sale.

			org		63803			; Esto lo ajustar adnde ms me convenga luego.
			
;; Aqu vienen todos los datos. Se pokean desde BASIC

datap:								; Cada bloque ocupa 40 bytes.

;; Sprite 1

udgs1:		defb	0, 0, 0, 0		; Los cuatro UDGs del primer sprite.
x_pos1:		defb	0				; Posicin X en chars.
y_pos1:		defb	0				; Posicin Y en chars.
cx_pos1:	defb	0				; Anterior posicin X en chars.
cy_pos1:	defb 	0				; Anterior posicin Y en chars.
buffer1:	defs	32, 0			; Buffer de lo que haba en la pantalla.
attrs1:		defb	7, 7, 7, 7		; Cuatro atributos
buffatrs1:	defs	4, 0			; Buffer de los atributos

;; Sprite 2

udgs2:		defb	0, 0, 0, 0		; Los cuatro UDGs del segundo sprite.
x_pos2:		defb	0				; Posicin X en chars.
y_pos2:		defb	0				; Posicin Y en chars.
cx_pos2:	defb	0				; Anterior posicin X en chars.
cy_pos2:	defb 	0				; Anterior posicin Y en chars.
buffer2:	defs	32, 0			; Buffer de lo que haba en la pantalla.
attrs2:		defb	7, 7, 7, 7		; Cuatro atributos
buffatrs2:	defs	4, 0			; Buffer de los atributos

;; Sprite 3

udgs3:		defb	0, 0, 0, 0		; Los cuatro UDGs del tercer sprite.
x_pos3:		defb	0				; Posicin X en chars.
y_pos3:		defb	0				; Posicin Y en chars.
cx_pos3:	defb	0				; Anterior posicin X en chars.
cy_pos3:	defb 	0				; Anterior posicin Y en chars.
buffer3:	defs	32, 0			; Buffer de lo que haba en la pantalla.
attrs3:		defb	7, 7, 7, 7		; Cuatro atributos
buffatrs3:	defs	4, 0			; Buffer de los atributos

;; Sprite 4

udgs4:		defb	0, 0, 0, 0		; Los cuatro UDGs del cuarto sprite.
x_pos4:		defb	0				; Posicin X en chars.
y_pos4:		defb	0				; Posicin Y en chars.
cx_pos4:	defb	0				; Anterior posicin X en chars.
cy_pos4:	defb 	0				; Anterior posicin Y en chars.
buffer4:	defs	32, 0			; Buffer de lo que haba en la pantalla.
attrs4:		defb	7, 7, 7, 7		; Cuatro atributos
buffatrs4:	defs	4, 0			; Buffer de los atributos

;; General y guarro, que todava estoy empezando:

xpos:		defb 	0
ypos:		defb 	0
cxpos:		defb	0
cypos:		defb 	0

;; El control de sprites se realiza escribiendo un valor
;; concreto en el primer UDG del sprite, por ejemplo 99.
;; Si vale 99, el sprite no se dibujar.

;; Primero tendremos que llamar a esta funcin que escribe lo que haya en
;; en fondo en el buffer de cada sprite.

init_sprites:						

; pointer = datap
; for (i = 0; i < 4; i ++) {
;    X = *(pointer + 4);									// A
;    Y = *(pointer + 5);
;    scr_address = get_scr_address (X, Y);					// B
;	 for (j = 0; j < 8; j ++) {
;       *(pointer + 8 + j) = *scraddress;
;       scraddress += 256;
;    }
;    scr_address = get_scr_address (X+1, Y);				// C
;	 for (j = 0; j < 8; j ++) {
;       *(pointer + 16 + j) = *scraddress;
;       scraddress += 256;
;    }
;    scr_address = get_scr_address (X, Y+1);				// D
;	 for (j = 0; j < 8; j ++) {
;       *(pointer + 24 + j) = *scraddress;
;       scraddress += 256;
;    }
;    scr_address = get_scr_address (X+1, Y+1);				// E
;	 for (j = 0; j < 8; j ++) {
;       *(pointer + 32 + j) = *scraddress;
;       scraddress += 256;
;    }
;    pointer = pointer + 40;
; }

			ld 		de, datap		; Apuntamos a la zona de datos

			ld		b,	4			; 4 iteraciones
i4chars:	push	bc
			
			;; Control: ver si dibujamos este sprite.
			ld		a,	(de)
			cp		99
			jr		z,	nxt1

			;; A

			inc		de
			inc		de
			inc		de
			inc		de

			; Obtenemos xpos
			ld		a,	(de)
			ld		hl,	xpos
			ld		(hl), a
			
			inc 	de
			
			; Obtenemos ypos
			ld		a,	(de)
			ld		hl, ypos
			ld		(hl), a
			
			inc 	de
			inc 	de
			inc 	de
			
			;; B
			
			; Pintamos el primer char
			call	copia_char
			
			; xpos++
			ld		hl, xpos
			inc		(hl)
			
			;; C
			
			; Pintamos el segundo char
			call 	copia_char

			; xpos --
			ld		hl, xpos
			ld		a, (hl)
			dec		a
			ld		(hl), a
			
			; ypos ++
			ld		hl, ypos
			inc		(hl)
			
			;; D
			
			; Pintamos el tercer char
			call 	copia_char

			; xpos++
			ld		hl, xpos
			inc		(hl)
			
			;; E
			
			; Pintamos el cuarto char
			call	copia_char
			
			;; Ya hemos copiado los 4 chars del sprite actual
			;; Con los incrementos de "de", ahora apunta 40 bytes ms adelante.
			
			;; Ahora los atributos
			
			;; Apuntamos con de al buffer de atributos, en datap+44,
			;; como estamos en datap+40, sumamos 4:
			inc		de
			inc		de
			inc		de
			inc		de
			
			;; reposicionamos las coordenadas xpos e ypos restando 1 a cada una:
			
			; xpos --
			ld		hl, xpos
			ld		a, (hl)
			dec		a
			ld		(hl), a
			
			; ypos --
			ld		hl, ypos
			ld		a, (hl)
			dec		a
			ld		(hl), a
					
			; Calculamos la direccin de la pantalla en BC
			call	get_attr_address
			
			; Copiamos los cuatro atributos
			ld		l, 	c
			ld		h, 	b
			ld		bc, 31
			ld		a,	(hl)
			ld		(de), a			; Primer carcter
			inc		hl
			inc		de				
			ld		a, 	(hl)	
			ld		(de), a			; Segundo carcter
			add		hl,	bc
			inc		de
			ld		a,	(hl)
			ld		(de), a			; Tercer carcter
			inc		hl
			inc		de
			ld		a, 	(hl)
			ld		(de), a			; Cuarto carcter
			inc		de				
			
			; Fin del bucle
			
nxt1:		pop		bc
			djnz 	i4chars
			
			ret
			
copia_char:
			call	get_scr_address	; Direccin (xpos, ypos) en BC
			ld		l, 	c
			ld		h, 	b			; Direccin (xpos, ypos) en HL
			
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			ld		a,	(hl)
			ld		(de), a
			inc		h
			inc		de
			
			ret
			
;; Esta funcin se encarga de mover los sprites,
;; con suerte lo suficientemente rpido para que no me pille el retrazo.
;; ** An no ** Solo actuar si x <> cx o y <> cy para cada uno de los cuatro sprites.

;; Lo ms fuerte es que init_sprites me ha funcionao de tirona, soy un genio :D
;; Pero esta es ms complic, a ver qu sale :)			

update_sprites:
	halt
	
	call borra_sprites				; Primero borramos con el fondo	
	call init_sprites               ; Obtenemos el nuevo fondo
	call draw_sprites				; Pintamos los UDGs
	call update_coordinates			; Para terminar, hacemos CX = X y CY = Y para los cuatro sprites
	
	ret

;; Esta funcin escribe el buffer en la pantalla para borrar los sprites.
;; Hace lo contrario que init_sprites pero usando las coordenadas CX y CY
;; en vez de X e Y.	

borra_sprites:

; pointer = datap
; for (i = 0; i < 4; i ++) {
;	 CX = *(pointer + 6)
;	 CY = *(pointer + 7)
;    scr_address = get_scr_address (CX, CY);
;    for (j = 0; j < 8; j ++) {
;    	*scr_address = *(pointer + 8 + j);
;		scr_address += 256;
;    }
;    scr_address = get_scr_address (CX+1, CY);
;    for (j = 0; j < 8; j ++) {
;    	*scr_address = *(pointer + 16 + j);
;		scr_address += 256;
;    }
;    scr_address = get_scr_address (CX, CY+1);
;    for (j = 0; j < 8; j ++) {
;    	*scr_address = *(pointer + 24 + j);
;		scr_address += 256;
;    }
;    scr_address = get_scr_address (CX+1, CY+1);
;    for (j = 0; j < 8; j ++) {
;    	*scr_address = *(pointer + 32 + j);
;		scr_address += 256;
;    }
;    pointer += 40;
; }

			ld 		de, datap		; Apuntamos a la zona de datos

			ld		b,	4			; 4 iteraciones
i4chars2:	push	bc
			
			;; Control: ver si dibujamos este sprite.
			ld		a,	(de)
			cp		99
			jr		z,	nxt2

			;; A

			inc		de
			inc		de
			inc		de
			inc		de
			inc		de
			inc		de
			
			; Obtenemos xpos = CX
			ld		a,	(de)
			ld		hl,	xpos
			ld		(hl), a
			
			inc 	de
			
			; Obtenemos ypos = CY
			ld		a,	(de)
			ld		hl, ypos
			ld		(hl), a
			
			inc 	de
			
			;; B
			
			; Pintamos el primer char
			call	borra_char
						
			; xpos++
			ld		hl, xpos
			inc		(hl)
			
			;; C
			
			; Pintamos el segundo char
			call	borra_char

			; xpos --
			ld		hl, xpos
			ld		a, (hl)
			dec		a
			ld		(hl), a
			
			; ypos ++
			ld		hl, ypos
			inc		(hl)
			
			;; D
			
			; Pintamos el tercer char
			call 	borra_char

			; xpos++
			ld		hl, xpos
			inc		(hl)
			
			;; E
			
			; Pintamos el cuarto char
			call	borra_char
			
			;; Ya hemos copiado los 4 chars del sprite actual, seguimos con los siguientes...
			;; Con los incrementos de "de", ahora apunta 40 bytes ms adelante.

			;; Ahora los atributos
			
			;; Apuntamos con de al buffer de atributos, en datap+44,
			;; como estamos en datap+40, sumamos 4:
			inc		de
			inc		de
			inc		de
			inc		de
			
			;; reposicionamos las coordenadas xpos e ypos restando 1 a cada una:
			
			; xpos --
			ld		hl, xpos
			ld		a, (hl)
			dec		a
			ld		(hl), a
			
			; ypos --
			ld		hl, ypos
			ld		a, (hl)
			dec		a
			ld		(hl), a
					
			; Calculamos la direccin de la pantalla en BC
			call	get_attr_address
			
			; Copiamos los cuatro atributos
			call	copyattrs
			
			; Fin del bucle
			
nxt2:		pop		bc
			djnz 	i4chars2			
		
			ret

borra_char:				
			call	get_scr_address	; Direccin (xpos, ypos) en BC
			ld		l, 	c
			ld		h, 	b			; Direccin (xpos, ypos) en HL
			
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			
			ret

			
;; Esta es la ms complicada, porque tengo que pintar UDGs y la indireccin
;; es doble.

;; En mi estructura tendr nmeros de 0 a 21. La direccin del grfico que tengo
;; que pintar en la pantalla se averigua haciendo el clculo:

;; *(23675) + 256 * *(23676) + 8 * N
			
bufchars:	defs	4, 0			; Para guardar los cuatro UDGs del sprite actual

draw_sprites:

			ld 		de, datap		; Apuntamos a la zona de datos

			ld		b,	4			; 4 iteraciones
i4chars3:	push	bc

			;; Control: ver si dibujamos este sprite.
			ld		a,	(de)
			cp		99
			jr		z,	nxt3

			;; copiar aqu "de" a un buffer

			call	charsabuff
			
			; Obtenemos xpos
			ld		a,	(de)
			ld		hl,	xpos
			ld		(hl), a
			
			inc 	de
			
			; Obtenemos ypos
			ld		a,	(de)
			ld		hl, ypos
			ld		(hl), a
			
			inc 	de
			inc 	de
			inc 	de
			
			push 	de
			
			;;	Ahora vamos a calcular en de la direccin de inicio del grfico
			;;	Que queremos pintar.
			
			ld		hl, bufchars
			call	getde
			
			;;  Dios mo, la que he liao... No s ni lo que he hecho.
			
			; Pintamos el primer char
			call	docopy
			
			; xpos++
			ld		hl, xpos
			inc		(hl)
			
			; Direccin del grfico
			
			ld		hl, bufchars
			inc		hl
			call	getde
			
			; Pintamos el segundo char
			call	docopy
			
			; xpos--
			ld		hl, xpos
			ld		a, (hl)
			dec		a
			ld		(hl), a
			
			; ypos ++
			ld		hl, ypos
			inc		(hl)
			
			; Direccin del grfico
			
			ld		hl, bufchars
			inc		hl
			inc		hl
			call	getde
			
			; Pintamos el tercer char
			call	docopy
			
			; xpos ++
			ld		hl, xpos
			inc		(hl)
			
			; Direccin del grfico
			
			ld		hl, bufchars
			inc		hl
			inc		hl
			inc		hl
			call 	getde
			
			; Pintamos el cuarto char
			call	docopy
							
			pop		de
			
			; de = de + 32
			ld		bc, 32
			ld		h, d
			ld		l, e
			add		hl, bc
			ld		d, h
			ld		e, l
			
			;; Ahora los atributos
			
			;; Apuntamos con de al buffer de atributos, en datap+40
			;; Ya estamos en datap + 40.
			
			;; reposicionamos las coordenadas xpos e ypos restando 1 a cada una:
			
			; xpos --
			ld		hl, xpos
			ld		a, (hl)
			dec		a
			ld		(hl), a
			
			; ypos --
			ld		hl, ypos
			ld		a, (hl)
			dec		a
			ld		(hl), a
					
			; Calculamos la direccin de la pantalla en BC
			call	get_attr_address
			
			; Copiamos los cuatro atributos
			call	copyattrs
			
			inc		de
			inc		de
			inc		de
			inc		de				; Ahora de apunta a datap+48, o sea, al siguiente sprite.
			
			; Fin del bucle
			
nxt3:		pop		bc
			djnz 	i4chars3
			
			ret

charsabuff: ld		hl,	bufchars
			ld		a, (de)
			ld		(hl), a
			inc		de
			inc		hl
			ld		a, (de)
			ld		(hl), a
			inc		de
			inc		hl
			ld		a, (de)
			ld		(hl), a
			inc		de
			inc		hl
			ld		a, (de)
			ld		(hl), a
			inc		de
			inc		hl
			ret
						
copyattrs:	ld		l, 	c
			ld		h, 	b
			ld		bc, 31
			ld		a,	(de)
			ld		(hl), a			; Primer carcter
			inc		hl
			inc		de				
			ld		a, 	(de)	
			ld		(hl), a			; Segundo carcter
			add		hl,	bc
			inc		de
			ld		a,	(de)
			ld		(hl), a			; Tercer carcter
			inc		hl
			inc		de
			ld		a, 	(de)
			ld		(hl), a			; Cuarto carcter
			inc		de				; Ahora de apunta a datap+48, o sea, al siguiente sprite.
			ret
			
update_coordinates:
			ld 		de, datap		; Apuntamos a la zona de datos
			ld		hl, datap		; idem

			ld		b,	4			; 4 iteraciones
i4chars4:	push	bc

			;; Para cada sprite hay que hacer:
			;; *(datap + 6) = *(datap + 4)
			;; *(datap + 7) = *(datap + 5)
			
			inc		de
			inc		de
			inc		de
			inc		de
			ld		a, (de)			; a = X
			inc		hl
			inc		hl
			inc 	hl
			inc		hl
			inc		hl
			inc		hl
			ld		(hl), a			; CX = a
			
			inc 	de
			ld		a, (de)			; a = Y
			inc 	hl
			ld		(hl), a			; CY = a

			inc		hl
			
			;; hl = hl + 40
			ld		bc, 40
			add		hl, bc
			
			;; de = hl
			ld		d, h
			ld		e, l
			
			pop		bc
			djnz 	i4chars4
			ret
			
;; Esta funcin calcula la posicin en memoria del UDG apuntado por
;; el nmero que est en la direccin hl.
			
getde:		ld		a, (hl)
			ld		d, a
			ld		hl, 23676
			ld		a, (hl)
			ld		e, a
			ld		hl, 23675
			ld		a, (hl)
			ld		l, a
			ld		a, e
			ld		h, a
			;;		HL = *(23675) + 256 * *(23676)
			ld		a, d
			rlca
			rlca
			rlca	; a = N * 8
			ld		d, 0
			ld		e, a
			add		hl, de
			ld		d, h
			ld		e, l
			ret

docopy:		
			call	get_scr_address	; Direccin (xpos, ypos) en BC
			ld		l, 	c
			ld		h, 	b			; Direccin (xpos, ypos) en HL			
			
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			ld		a,	(de)
			ld		(hl), a
			inc		h
			inc		de
			
			ret
			
;; Esta funcin devuelve en bc la direccin de memoria
;; de la posicin (xpos, ypos) en carcteres. Extrado de cdigo
;; por BloodBaz.

get_scr_address:
			push 	de
			ld 		a,	(xpos)
			and		31
			ld		c,	a
			ld		a,	(ypos)
			ld		d,	a
			and		24
			add		a,	64
			ld		b, 	a
			ld		a,	d
			and		7
			rrca
			rrca
			rrca
			or		c
			ld		c, 	a
			pop		de
			ret
					
;; Esta funcin devuelve en bc la direccin de memoria
;; de la posicin (xpos, ypos) dentro del archivo de atributos.
;; Adaptado de cdigo por Jonathan Cauldwell.

;; 010110YY YYYXXXXX

get_attr_address:
			
			ld		a, 	(ypos)		; Cogemos y
			rrca
			rrca
			rrca					; La multiplicamos por 32
			ld		c,	a			; nos lo guardamos en c
			and		3				; ponemos una mascarita 00000011
			add		a,	88			; 88 * 256 = 22528, aqu empieza el tema
			ld		b,	a			; Hecho el bite superior.
			ld		a,	c			; Nos volvemos a traer y * 32
			and		224				; Mascarita 11100000
			ld		c,	a			; Lo volvemos a poner en c
			ld		a,	(xpos)		; Cogemos x
			add		a, 	c			; Le sumamos lo que tenamos antes.
			ld		c,	a			; Listo. Ya tenemos en BC la direccin.
			
			ret
			
spare:		defs	8, 85